题解:Codeforces Round 967 (Div. 2) A [暴力/贪心]

2024-08-21 19:44

本文主要是介绍题解:Codeforces Round 967 (Div. 2) A [暴力/贪心],希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

A. Make All Equal

time limit per test: 1 second

memory limit per test: 256 megabytes

input: standard input

output: standard output

You are given a cyclic array a 1 , a 2 , … , a n a_1, a_2, \ldots, a_n a1,a2,,an.

You can perform the following operation on a a a at most n − 1 n - 1 n1 times:

  • Let m m m be the current size of a a a, you can choose any two adjacent elements where the previous one is no greater than the latter one (In particular, a m a_m am and a 1 a_1 a1 are adjacent and a m a_m am is the previous one), and delete exactly one of them. In other words, choose an integer i i i ( 1 ≤ i ≤ m 1 \leq i \leq m 1im) where a i ≤ a ( i m o d m ) + 1 a_i \leq a_{(i \bmod m) + 1} aia(imodm)+1 holds, and delete exactly one of a i a_i ai or a ( i m o d m ) + 1 a_{(i \bmod m) + 1} a(imodm)+1 from a a a.

Your goal is to find the minimum number of operations needed to make all elements in a a a equal.

给你一个循环数组 a 1 , a 2 , … , a n a_1, a_2, \ldots, a_n a1,a2,,an

你最多可以对 a a a 执行 n − 1 n - 1 n1 次以下操作:

  • 假设 m m m a a a 的当前大小,你可以选择任意两个相邻的元素,其中前一个元素不大于后一个元素(特别是 a m a_m am a 1 a_1 a1 是相邻的,而 a m a_m am 是前一个元素),并恰好删除其中一个元素。换句话说,选择一个 a i ≤ a ( i m o d m ) + 1 a_i \leq a_{(i \bmod m) + 1} aia(imodm)+1 成立的整数 i i i 1 ≤ i ≤ m 1 \leq i \leq m 1im ),并从 a a a 中恰好删除 a i a_i ai a ( i m o d m ) + 1 a_{(i \bmod m) + 1} a(imodm)+1 中的一个。

你的目标是找出使 a a a 中所有元素相等所需的最少运算次数。

Input

Each test contains multiple test cases. The first line contains the number of test cases t t t ( 1 ≤ t ≤ 500 1 \le t \le 500 1t500). The description of the test cases follows.

The first line of each test case contains a single integer n n n ( 1 ≤ n ≤ 100 1 \le n \le 100 1n100) — the length of the array a a a.

The second line of each test case contains n n n integers a 1 , a 2 , … , a n a_1, a_2, \ldots, a_n a1,a2,,an ( 1 ≤ a i ≤ n 1 \le a_i \le n 1ain) — the elements of array a a a.

输入

每个测试包含多个测试用例。第一行包含测试用例的数量 t t t ( 1 ≤ t ≤ 500 1 \le t \le 500 1t500 )。测试用例说明如下。

每个测试用例的第一行包含一个整数 n n n ( 1 ≤ n ≤ 100 1 \le n \le 100 1n100 ) - 数组的长度 a a a

每个测试用例的第二行包含 n n n 个整数 a 1 , a 2 , … , a n a_1, a_2, \ldots, a_n a1,a2,,an ( 1 ≤ a i ≤ n 1 \le a_i \le n 1ain ) - 数组 a a a 的元素。

Output

For each test case, output a single line containing an integer: the minimum number of operations needed to make all elements in a a a equal.

输出

对于每个测试用例,输出一行包含一个整数:使 a a a 中所有元素相等所需的最少操作数。

Example

Input
7
1
1
3
1 2 3
3
1 2 2
5
5 4 3 2 1
6
1 1 2 2 3 3
8
8 7 6 3 8 7 6 3
6
1 1 4 5 1 4
Output
0
2
1
4
4
6
3

Note

In the first test case, there is only one element in a a a, so we can’t do any operation.

In the second test case, we can perform the following operations to make all elements in a a a equal:

  • choose i = 2 i = 2 i=2, delete a 3 a_3 a3, then a a a would become [ 1 , 2 ] [1, 2] [1,2].
  • choose i = 1 i = 1 i=1, delete a 1 a_1 a1, then a a a would become [ 2 ] [2] [2].

It can be proven that we can’t make all elements in a a a equal using fewer than 2 2 2 operations, so the answer is 2 2 2.

在第一个测试用例中, a a a 中只有一个元素,因此我们无法进行任何操作。

在第二个测试用例中,我们可以执行以下操作,使 a a a 中的所有元素相等:

  • 选择 i = 2 i = 2 i=2 ,删除 a 3 a_3 a3 ,那么 a a a 将变为 [ 1 , 2 ] [1, 2] [1,2]
  • 选择 i = 1 i = 1 i=1 ,删除 a 1 a_1 a1 ,则 a a a 将变为 [ 2 ] [2] [2]

可以证明,使用少于 2 2 2 的运算无法使 a a a 中的所有元素相等,因此答案是 2 2 2

题意

有一个循环数组 a a a
你每次可以操作:

对数组中相邻两个不同的数字删去任意一个(首尾两个也算相邻)
你需要不断操作,直到数组中只有一种元素时停止
问:你至少需要操作多少次

题解

只需要用一个map存储某种数字出现的个数
然后最后的数组就是全部那种数字了
所以只需要输出
数组总数 − 出现最多数字的个数 数组总数 - 出现最多数字的个数 数组总数出现最多数字的个数
即可

代码

#include <bits/stdc++.h>
#define int long long
#define INF 0x3f3f3f3f
#define all(x) x.begin(),x.end()using i64 = long long;
const int N = 2e5 + 10;
int t = 1;
int a[N];void solve() {std::map<int,int> mp;int n;std::cin >> n;int max = 0;for(int i = 0 ; i < n ; i ++) {int num;std::cin >> num;mp[num]++;max = std::max(max,mp[num]);}std::cout << n - max << "\n";
}signed main(){std::ios::sync_with_stdio(false);std::cin.tie(nullptr);std::cin >> t;while(t--){solve();}return 0;
}

有什么建议或者意见的欢迎在评论区留言!

转载自博客https://www.cnblogs.com/jiejiejiang2004/p/18371667
博主已同意,我就是博主

这篇关于题解:Codeforces Round 967 (Div. 2) A [暴力/贪心]的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/1094105

相关文章

usaco 1.3 Barn Repair(贪心)

思路:用上M块木板时有 M-1 个间隙。目标是让总间隙最大。将相邻两个有牛的牛棚之间间隔的牛棚数排序,选取最大的M-1个作为间隙,其余地方用木板盖住。 做法: 1.若,板(M) 的数目大于或等于 牛棚中有牛的数目(C),则 目测 给每个牛牛发一个板就为最小的需求~ 2.否则,先对 牛牛们的门牌号排序,然后 用一个数组 blank[ ] 记录两门牌号之间的距离,然后 用数组 an

poj 3190 优先队列+贪心

题意: 有n头牛,分别给他们挤奶的时间。 然后每头牛挤奶的时候都要在一个stall里面,并且每个stall每次只能占用一头牛。 问最少需要多少个stall,并输出每头牛所在的stall。 e.g 样例: INPUT: 51 102 43 65 84 7 OUTPUT: 412324 HINT: Explanation of the s

poj 2976 分数规划二分贪心(部分对总体的贡献度) poj 3111

poj 2976: 题意: 在n场考试中,每场考试共有b题,答对的题目有a题。 允许去掉k场考试,求能达到的最高正确率是多少。 解析: 假设已知准确率为x,则每场考试对于准确率的贡献值为: a - b * x,将贡献值大的排序排在前面舍弃掉后k个。 然后二分x就行了。 代码: #include <iostream>#include <cstdio>#incl

Codeforces Round #240 (Div. 2) E分治算法探究1

Codeforces Round #240 (Div. 2) E  http://codeforces.com/contest/415/problem/E 2^n个数,每次操作将其分成2^q份,对于每一份内部的数进行翻转(逆序),每次操作完后输出操作后新序列的逆序对数。 图一:  划分子问题。 图二: 分而治之,=>  合并 。 图三: 回溯:

Codeforces Round #261 (Div. 2)小记

A  XX注意最后输出满足条件,我也不知道为什么写的这么长。 #define X first#define Y secondvector<pair<int , int> > a ;int can(pair<int , int> c){return -1000 <= c.X && c.X <= 1000&& -1000 <= c.Y && c.Y <= 1000 ;}int m

Codeforces Beta Round #47 C凸包 (最终写法)

题意慢慢看。 typedef long long LL ;int cmp(double x){if(fabs(x) < 1e-8) return 0 ;return x > 0 ? 1 : -1 ;}struct point{double x , y ;point(){}point(double _x , double _y):x(_x) , y(_y){}point op

Codeforces Round #113 (Div. 2) B 判断多边形是否在凸包内

题目点击打开链接 凸多边形A, 多边形B, 判断B是否严格在A内。  注意AB有重点 。  将A,B上的点合在一起求凸包,如果凸包上的点是B的某个点,则B肯定不在A内。 或者说B上的某点在凸包的边上则也说明B不严格在A里面。 这个处理有个巧妙的方法,只需在求凸包的时候, <=  改成< 也就是说凸包一条边上的所有点都重复点都记录在凸包里面了。 另外不能去重点。 int

C++ | Leetcode C++题解之第393题UTF-8编码验证

题目: 题解: class Solution {public:static const int MASK1 = 1 << 7;static const int MASK2 = (1 << 7) + (1 << 6);bool isValid(int num) {return (num & MASK2) == MASK1;}int getBytes(int num) {if ((num &

Codeforces 482B 线段树

求是否存在这样的n个数; m次操作,每次操作就是三个数 l ,r,val          a[l] & a[l+1] &......&a[r] = val 就是区间l---r上的与的值为val 。 也就是意味着区间[L , R] 每个数要执行 | val 操作  最后判断  a[l] & a[l+1] &......&a[r] 是否= val import ja

POJ2010 贪心优先队列

c头牛,需要选n头(奇数);学校总共有f的资金, 每头牛分数score和学费cost,问合法招生方案中,中间分数(即排名第(n+1)/2)最高的是多少。 n头牛按照先score后cost从小到大排序; 枚举中间score的牛,  预处理左边与右边的最小花费和。 预处理直接优先队列贪心 public class Main {public static voi